/**
 * 
 */
package animation.demo;

import java.util.List;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IWorkbenchPart;

/**
 * @author Tony Modica
 *
 */
public class AnimatingDemoAction1 extends SelectionAction {

	static public final String ID = "AnimatingDemoAction1";
	
	private EObject selectedModel;
	
	public AnimatingDemoAction1(IWorkbenchPart part) {
		super(part);
		setDescription(ID);
		setText(ID);
		setId(ID);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
	@Override
	protected boolean calculateEnabled() {
		List selectedObjects = getSelectedObjects();
		if (selectedObjects.size() != 1) {
			return false;
		}
		Object selectedObject = selectedObjects.get(0);
		if (!(selectedObject instanceof EditPart)) {
			return false;
		}
		EditPart selectedEditPart = (EditPart) selectedObject;
		Object selectedModel = selectedEditPart.getModel();
		if (!(selectedModel instanceof EObject)) {
			return false;
		}
		this.selectedModel = (EObject) selectedModel;	
		return this.selectedModel.eContents().size() >= 2;
	}

	@Override
	public void run() {
		execute(new AnimatingDemoCommand1(selectedModel));
	}
	
}
