/**
 * 
 */
package animation.demo;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;

import animation.AnimatingCommand;

/**
 * @author Tony Modica
 * 
 */
public class AnimatingDemoCommand1 extends AnimatingCommand {

	private Object model;

	public AnimatingDemoCommand1(EObject model) {
		this.model = model;
		EList<EObject> children = model.eContents();
		EObject movingChild = children.get(0);

		// initialize animated elements

		//initializeAnimatedElement(model, model.eContainer());
		// angepasst an RON model, da das RON das oberste angezeigte Modell im Viewer ist
		initializeAnimatedElement(model, model.eContainer().eContainer());
		
		initializeAnimatedElement(movingChild, model);

		// initial positions
		specifyStep(model, model);
		specifyStep(movingChild, movingChild);
		
		for (int actualStep = 1; actualStep < children.size(); actualStep++) {
			nextStep();
			specifyStep(movingChild, children.get(actualStep));
			if (actualStep == (children.size() - 1) / 2) {
				specifyStep(model, model, 4);
			}
		}
		specifyStep(model, model, 1);
	}
}
