package roneditor.commands;

import ronmodel.HLPlace;
import ronmodel.Rule;
import ronmodel.Token;

/**
 * Command for creating a Token and add these token to a HLPlace. This is undoable.
 * 
 * @author Tony Modica
 */
public class CreateHLTokenCommand extends org.eclipse.gef.commands.Command {

	private static final String CreateCommand_Label = "Create Token";

	final private HLPlace place;

	private final Token token;
	
	private int ID=-1;

	private String name;

	public CreateHLTokenCommand(final HLPlace place, final Token token, final int ID) {
		super(CreateHLTokenCommand.CreateCommand_Label);
		this.place = place;
		this.token = token;	
		this.ID=ID;
	}
	
	public CreateHLTokenCommand(final HLPlace place, final Token token) {
		super(CreateHLTokenCommand.CreateCommand_Label);
		this.place = place;
		this.token = token;	
	}
	
	/**
	 * Executes the command by adding the Net to the HLPlace.
	 */
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	@Override
	public void execute() {
		token.setName(name);
		if (token instanceof Rule)
			((Rule)token).setID(ID);
		token.setPlace(place);
	}

	/**
	 * Undoes the command by removing the Token from the HLPlace.
	 */
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	@Override
	public void undo() {
		token.setPlace(null);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	@Override
	public void redo() {
		token.setPlace(place);
	}

	/*
	 * Can execute command if name!=null and
	 * either the token is no rule
	 * or the token is a rule and ID>-1
	 */
	@Override
	public boolean canExecute() {
		return (name != null && 
			   ((token instanceof Rule && ID>-1) || !(token instanceof Rule)));
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(final String name) {
		this.name = name;
	}
}
