/**
 *
 */
package roneditor.dialogs.chooseObjNet;

import java.util.List;

import org.eclipse.gef.EditPartFactory;

import roneditor.objectnetview.edit.utils.ObjectNetViewEditPartFactory;
import ronmodel.ONArc;
import ronmodel.ONPlace;
import ronmodel.ONTransition;
import ronmodel.ObjectNet;

/**
 * @author Tony Modica
 * 
 */
public class ChooseObjNetDialog extends AbstractChooseObjNetDialog {

	/**
	 * @param objectNets
	 */
	public ChooseObjNetDialog(final List<ObjectNet> objectNets) {
		super(objectNets);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see roneditor.dialogs.fire.AbstractFireDialog#getEditPartFactory()
	 */
	@Override
	protected EditPartFactory getEditPartFactory() {
		return new ObjectNetViewEditPartFactory();
	}

	@Override
	protected boolean isActivated(final ONTransition transition) {
		for (final Object elem : transition.getIncoming()) {
			final ONArc arc = (ONArc) elem;
			final ONPlace prePlace = (ONPlace) arc.getSource();
			if (prePlace.getTokens() < arc.getWeight()) {
				return false;
			}
		}
		return true;
	}

}
