/**
 * 
 */
package roneditor.edit.policies;

import org.eclipse.draw2d.Label;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;

import roneditor.commands.RenameNamedElementCommand;
import roneditor.edit.parts.LabelEditPart;

public class LabelDirectEditPolicy extends DirectEditPolicy {

		public LabelDirectEditPolicy() {
			super();
		}

		
		
		
		/**
		 * Holt sich vom CellEditor den neuen namen und erstellt ein passendes Command
		 * 
		 */
		protected Command getDirectEditCommand (DirectEditRequest edit) {
			String labelText = (String) edit.getCellEditor().getValue ();
			LabelEditPart labelEditPart = (LabelEditPart)getHost();
			RenameNamedElementCommand command = new RenameNamedElementCommand((labelEditPart.getCastedModel()));
			command.setNewName(labelText);
			return command ;
		}
		
		
		/** 
		 * Ermglicht das die Figure sich schon whrend des Editierens mitndert.
		 * 
		 */
		protected void showCurrentEditValue(DirectEditRequest request) {
			String value = (String)request.getCellEditor().getValue();
			((Label)getHostFigure()).setText(value);
			//hack to prevent async layout from placing the cell editor twice.
			getHostFigure().getUpdateManager().performUpdate();
			
		}

}
