package roneditor.edit.utils;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.tools.DirectEditManager;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Text;

import roneditor.ronview.edit.policies.HLNodeLabelCellEditorLocator;

public class LabelEditManager extends DirectEditManager implements
		ModifyListener {

	Font scaledFont;

	private Label label;

	private String name;

	public LabelEditManager(final GraphicalEditPart source,
			final Class editorType, final Label label) {
		super(source, editorType, new HLNodeLabelCellEditorLocator(label));
		this.label = label;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.tools.DirectEditManager#bringDown()
	 */
	@Override
	protected void bringDown() {
		final Font disposeFont = scaledFont;
		scaledFont = null;
		super.bringDown();
		if (disposeFont != null) {
			disposeFont.dispose();
		}
	}


	
	
	/**
	 * Initialisiert den CellEditor
	 */
	@Override
	protected void initCellEditor() {
		final Text text = (Text) getCellEditor().getControl();
		getCellEditor().setValue(name);
		final IFigure figure = getEditPart().getFigure();
		scaledFont = figure.getFont();
		final FontData data = scaledFont.getFontData()[0];
		final Dimension fontSize = new Dimension(0, data.getHeight());
		label.translateToAbsolute(fontSize);
		data.setHeight(fontSize.height);
		scaledFont = new Font(null, data);
		text.setFont(scaledFont);
		text.selectAll();
	}

	public void modifyText(final ModifyEvent e) {
		System.out.println("test");
	}

	
	
	/**
	 * @param name Text der am Anfang im CellEditor stehen soll
	 */
	public void setName(final String name) {
		if (name == null) {
			this.name = "";
		} else {
			this.name = name;
		}
	}

}
