package roneditor.objectnetview;


import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.ConnectionCreationTool;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Shell;

import roneditor.objectnetview.commands.ConnectionONPlaceONTransCommand;
import roneditor.objectnetview.commands.ConnectionONTransONPlaceCommand;
import roneditor.objectnetview.dialog.ONArcPropertiesDialog;

public class ObjectNetConnectionCreationTool extends ConnectionCreationTool {

	private Notifier target;
	
	public ObjectNetConnectionCreationTool() {
		super();
	}
	
	public ObjectNetConnectionCreationTool(CreationFactory factory) {
		super(factory);
	}
	
	protected void executeCurrentCommand() {
		Command command = getCurrentCommand();
		if ((command instanceof ConnectionONPlaceONTransCommand) && command.canExecute()){
			if(!openONArcRoleDialog(command))
				return;
		}
		else if ((command instanceof ConnectionONTransONPlaceCommand) && command.canExecute()){
			if(!openONArcRoleDialog(command))
				return;
		}
		super.executeCurrentCommand();
	}
	
	private boolean openONArcRoleDialog(Command command){
	/*	String heading = new String();
		
		if (command instanceof ConnectionONPlaceONTransCommand)
			heading = "Create ONArc";
		else if (command instanceof ConnectionONTransONPlaceCommand)
			heading = "Create ONArc";*/
		
		ONArcPropertiesDialog d = new ONArcPropertiesDialog(new Shell(), SWT.NULL);
		d.setText("Create ONArc");
		d.open();
		if(d.isCancelled()){
			return false;
		}
		
		if (command instanceof ConnectionONPlaceONTransCommand)
			((ConnectionONPlaceONTransCommand)command).setWeight(d.getWeight());
		else if (command instanceof ConnectionONTransONPlaceCommand)
			((ConnectionONTransONPlaceCommand)command).setWeight(d.getWeight());
		
        return true;
    }	
}