package roneditor.objectnetview;


import java.util.Map;

import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.requests.CreationFactory;
import org.eclipse.gef.tools.CreationTool;

import roneditor.edit.parts.LabelEditPart;
import roneditor.objectnetview.commands.CreateONPlaceCommand;
import roneditor.objectnetview.commands.CreateONTransitionCommand;
import roneditor.objectnetview.edit.parts.ONPlaceEditPart;
import roneditor.objectnetview.edit.parts.ONTransitionEditPart;
import ronmodel.ONPlace;
import ronmodel.ONTransition;

public class ObjectNetCreationTool extends CreationTool {

	public ObjectNetCreationTool() {
		super();
	}
	
	public ObjectNetCreationTool(CreationFactory factory) {
		super(factory);
	}
	
	protected void executeCurrentCommand() {
		Command command = getCurrentCommand();

		super.executeCurrentCommand();
		
		// direkt Edit kann erst nach dem Ausfhren des CreationCommands gemacht, werden.
		// Es wird der Name einfach nachtrglich umgendert vom Defaultwert.
		if ( command instanceof CreateONTransitionCommand ) {
			ONTransition transition = (ONTransition)((CreateONTransitionCommand)command).getONNode();
			Map reg = getCurrentViewer().getEditPartRegistry();
			ONTransitionEditPart editPart = (ONTransitionEditPart)reg.get(transition);
			LabelEditPart labelEditPart = editPart.getLabelEditPart();
			labelEditPart.getCastedModel().setName("");
			Request request = new Request(RequestConstants.REQ_DIRECT_EDIT);
			labelEditPart.performRequest(request);
		} else if ( command instanceof CreateONPlaceCommand ) {
			ONPlace place = (ONPlace)((CreateONPlaceCommand)command).getONNode();
			Map reg = getCurrentViewer().getEditPartRegistry();
			ONPlaceEditPart editPart = (ONPlaceEditPart)reg.get(place);
			LabelEditPart labelEditPart = editPart.getLabelEditPart();
			labelEditPart.getCastedModel().setName("");
			Request request = new Request(RequestConstants.REQ_DIRECT_EDIT);
			labelEditPart.performRequest(request);
		}
		
	}
	

	
}