package roneditor.objectnetview.commands;

import org.eclipse.gef.commands.Command;

import ronmodel.ONArc;

/**
 * Edit ONArc properties.
 */
public class EditONArcCommand extends Command{
	private ONArc onArc;
	private int oldWeight = 0;
	private int newWeight = 0;
	
	public EditONArcCommand(){
		setLabel("Edit ONArc");
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#execute()
	 */
	public void execute() {
		oldWeight = onArc.getWeight();
		onArc.setWeight(newWeight);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	public void undo() {
		onArc.setWeight(oldWeight);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	public void redo() {
		onArc.setWeight(newWeight);
	}

	/**
	 * @return the ONArc
	 */
	public ONArc getONArc() {
		return onArc;
	}

	/**
	 * @param ONArc the ONArc to set
	 */
	public void setONArc(ONArc newArc) {
		this.onArc = newArc;
	}

	/**
	 * @return the newWeight
	 */
	public int getNewWeight() {
		return newWeight;
	}

	/**
	 * @param newWeight the newWeight to set
	 */
	public void setNewWeight(int newWeight) {
		this.newWeight = newWeight;
	}

}
