package roneditor.objectnetview.commands;


import roneditor.model.RONModelManager;
import ronmodel.BendPoint;
import ronmodel.RonmodelFactory;

public class MoveBendpointCommand extends AbstractBendpointCommand{
	
	
	RonmodelFactory mcf = RONModelManager.getFactory();
	
	public void execute(){
		
		BendPoint bp = mcf.createBendPoint();
		
		bp.getH().add(new Integer(getFirstRelativeDimension().height));
		bp.getW().add(new Integer(getFirstRelativeDimension().width));
		
		bp.getH().add(new Integer(getSecondRelativeDimension().height));
		bp.getW().add(new Integer(getSecondRelativeDimension().width));	
		
		setOldBendpoint((BendPoint) getONArc().getBendpoints().get(getIndex()));
		
		getONArc().getBendpoints().set(getIndex(), bp);
	}
	
	public BendPoint getOldBendpoint(){
		return bendPoint;
	}
	
	public void setOldBendpoint(BendPoint bp){
		bendPoint = bp;
	}

	public void undo(){
		getONArc().getBendpoints().set(getIndex(), getOldBendpoint());

	}
}
