package roneditor.objectnetview.edit.policies;

// MARIO Direct Edit - die ganze Datei

import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Text;


public class ONNodeLabelCellEditorLocator implements CellEditorLocator {

	private Label label;

	public ONNodeLabelCellEditorLocator(final Label label) {
		this.label = label;
	}

	/**
	 * Position und Dimension des CellEditors anhand der LabelFigure berechnen und setzen 
	 */
	public void relocate(final CellEditor celleditor) {
		final Text text = (Text) celleditor.getControl();
		final Point pref = text.computeSize(-1, -1);
		final Rectangle rect = label.getTextBounds().getCopy();
		label.translateToAbsolute(rect);
		text.setBounds(rect.x - 4, rect.y - 1, pref.x + 1, pref.y + 1);
		// scheint keinen Sinn zu machen, aber Celleditor verhlt sich sonst komisch
		text.setSelection(0);
		text.setSelection(label.getText().length());
	}



}
