/**
 * 
 */
package roneditor.objectnetview.figures;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.RectangleFigure;
import org.eclipse.draw2d.XYLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;

/**
 * @author Mario
 *
 */
public class ONArcLabelFigure extends RectangleFigure {

	private Label weightLabel;
	
	public ONArcLabelFigure() {		
		this.setLayoutManager(new XYLayout());
		this.setOutline(false);
		this.setFill(true);
		this.setBackgroundColor(ColorConstants.white);
		weightLabel= new Label("");
		final FontData data = new FontData();
		data.setStyle(SWT.BOLD);
		data.setHeight(10);
		Font f = new Font(null, data);
		weightLabel.setFont(f);
		this.add(weightLabel);
	}

	@Override
	public void validate(){		
		
		Dimension d = weightLabel.getSize();
		
		this.setMaximumSize(d);
		this.setMinimumSize(d);
		this.setPreferredSize(d);
		
		getLayoutManager().setConstraint(weightLabel, new Rectangle(0,0,-1,-1));		
		
		super.validate();
	}
	
	
	
	
	public void setWeight(String w) {
		weightLabel.setText(w);
		validate();
	}
}
