package roneditor.ronview.actions;

import org.eclipse.core.resources.IResource;
import org.eclipse.jface.action.Action;
import org.eclipse.ui.IEditorPart;

import roneditor.editor.RONEditor;
import ronmodel.RON;
import _mapping_consistency.MappingConsistencyCheck;

public class CompleteMappingConsistencyCheckAction extends Action {

	static public final String ID = "CompleteMappingConsistencyCheck";
	
	private final IEditorPart editor;

	public CompleteMappingConsistencyCheckAction(final IEditorPart editor) {
		this.editor=editor;
		setId(ID);
		setText("Update Markers");
		setDescription("Does a complete mapping-consistency-check for the whole RON");
		setToolTipText("Does a complete mapping-consistency-check for the whole RON");
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	@Override
	public void run() {
		// create dialog
		RON ron=((RONEditor)editor).getModelRoot();
		IResource res=(IResource) editor.getAdapter(IResource.class);
		MappingConsistencyCheck.checkMappingConsistency(ron, res);
	}

}
