package roneditor.ronview.actions;

import java.util.List;

import org.eclipse.emf.common.util.EList;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IWorkbenchPart;

import roneditor.ronview.commands.DeleteHLBendpointCommand;
import roneditor.ronview.edit.parts.HLArcEditPart;
import ronmodel.BendPoint;
import ronmodel.HLArc;

public class DeleteHLBendPointAction extends SelectionAction {
	
	static public String ID = "Delete_BendPoints_Action";
	
	public DeleteHLBendPointAction(IWorkbenchPart part){
		super(part);
		setDescription("Delete BendPoints Action");
		setText("Delete BendPoints");
	}
	
	public void run() {
		execute(getCommand());
	}
	
	protected boolean calculateEnabled() {
		return canPerformAction();
}
	public Command getCommand(){
		
		Object selection =
			((StructuredSelection) getSelection()).getFirstElement();
		if (selection instanceof HLArcEditPart){
			
		EList p = (EList) ((HLArcEditPart) selection).getHLArc().getBendpoints();
		
		CompoundCommand compound = new CompoundCommand();
		for(Object ob:p){
			DeleteHLBendpointCommand bp = new DeleteHLBendpointCommand();
			compound.add(bp);
			bp.setHLArc(((BendPoint) ob).getHLArc());
		}
		return compound;
				}
//		}
		return null;
		
	}
	
	/*
	 * Returns true if the action could be executed, false otherwise.
	 */
	private boolean canPerformAction() {
		if (getSelectedObjects().isEmpty())
			return false;
		List parts = getSelectedObjects();
		if (parts.size()==1){
			Object o = parts.get(0);
			if (!(o instanceof EditPart))
				return false;
			EditPart part = (EditPart) o;			
			if (part.getModel() instanceof HLArc)
				return true;
			else
				return false;
		}
		return false;
	}
	
	protected void init() {
		super.init();
		setId(ID);
	}

}
