package roneditor.ronview.commands;


import ronmodel.HLNode;
import ronmodel.RON;


/**
 * Command for creating a place.
 */
public class AbstractCreateHLNodeCommand
	extends org.eclipse.gef.commands.Command
{
	protected HLNode hlNode;
	protected int x;
	protected int y;
	protected int labelX;
	protected int labelY;
	protected RON ron;
	protected String name;
	
/**
 * Constructor.
 *
 */	
	public AbstractCreateHLNodeCommand() {
		super();
	}
	
	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		hlNode.setName(name);
		hlNode.setX(x);
		hlNode.setY(y);
		hlNode.setLabelX(labelX);
		hlNode.setLabelY(labelY);
		hlNode.setRon(ron);
	}
	
	/**
	 * Redo command execution.
	 */
	public void redo() {
		hlNode.setRon(ron);
	}
	
	/**
	 * Undo command execution.
	 */
	public void undo() {
		hlNode.setRon(null);
	}

/**
 * @return the onPlace
 */
public HLNode getHLNode() {
	return hlNode;
}

/**
 * @param onPlace the onPlace to set
 */
//public void setHLNode(HLNode onNode) {
//	this.onNode = onNode;
//}

/**
 * @return the objectNet
 */
public RON getRON() {
	return ron;
}

/**
 * @param ron the ron to set
 */
public void setRON(RON ron) {
	this.ron = ron;
}

/**
 * @return the x
 */
public int getX() {
	return x;
}

/**
 * @param x the x to set
 */
public void setX(int x) {
	this.x = x;
}

/**
 * @return the y
 */
public int getY() {
	return y;
}

/**
 * @param y the y to set
 */
public void setY(int y) {
	this.y = y;
}

/**
 * @return the labelX
 */
public int getLabelX() {
	return labelX;
}

/**
 * @param x the x to set
 */
public void setLabelX(int labelX) {
	this.labelX = labelX;
}

/**
 * @return the labelY
 */
public int getLabelY() {
	return labelY;
}

/**
 * @param y the y to set
 */
public void setLabelY(int labelY) {
	this.labelY = labelY;
}


/**
 * @return the name
 */
public String getName() {
	return name;
}

/**
 * @param name the name to set
 */
public void setName(String name) {
	this.name = name;
}


}
