package roneditor.ronview.commands;

import ronmodel.HLPlace;
import ronmodel.HLTransition;


/**
 * Command class for a HLPlace/HLTransition connection.
 * Connects a HLPlace with a HLTransition via a HLArc.
 */
public class ConnectionHLPlaceHLTransCommand extends AbstractHLConnectionCommand {	
	private static final String ConnectionCommand_Description = 
		"HLArc: HLPlace connection command";

	/**
	 * Constructor.
	 */
	public ConnectionHLPlaceHLTransCommand() {
		super();
	}
	
	/**
	 * True if the command can be executed, false otherwise.
	 */
	public boolean canExecute() {
		if (source == null || target == null || hlArc == null || source == target)
			return false;
		else return true;
	}

	/**
	 * Returns the command label.
	 */
	public String getLabel() {
		return ConnectionCommand_Description;
	}

	public void setSource(HLPlace source) {
		super.setSource(source);
	}

	public void setTarget(HLTransition target) {
		super.setTarget(target);
	}

	/**
	 * @return the source
	 */
	@Override
	public HLPlace getSource() {
		return (HLPlace)source;
	}

	/**
	 * @return the target
	 */
	@Override
	public HLTransition getTarget() {
		return (HLTransition)target;
	}

}
