package roneditor.ronview.commands;

import ronmodel.HLPlace;
import ronmodel.HLTransition;


/**
 * Command class for a HLTransition/HLPlace connection.
 * Connects a HLTransition with a HLPlace via a HLArc.
 */
public class ConnectionHLTransHLPlaceCommand extends AbstractHLConnectionCommand {	
	private static final String ConnectionCommand_Description = 
		"HLArc: HLTransition connection command";
	
	/**
	 * Constructor.
	 */
	public ConnectionHLTransHLPlaceCommand() {
		super();
	}

	/**
	 * True if the command can be executed, false otherwise.
	 */
	public boolean canExecute() {
		if (source == null || target == null || hlArc == null || source == target)
			return false;
		else return true;
	}

	/**
	 * Returns the command label.
	 */
	public String getLabel() {
		return ConnectionCommand_Description;
	}
	
	public void setSource(HLTransition source) {
		super.setSource(source);
	}

	public void setTarget(HLPlace target) {
		super.setTarget(target);
	}

	/**
	 * @return the source
	 */
	@Override
	public HLTransition getSource() {
		return (HLTransition)source;
	}

	/**
	 * @return the target
	 */
	@Override
	public HLPlace getTarget() {
		return (HLPlace)target;
	}

}
