/**
 * 
 */
package roneditor.ronview.commands;

import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gef.commands.Command;

import ronmodel.HLPlace;
import ronmodel.Token;

/**
 * @author Mario
 *
 */
public class CopyHLTokenCommand extends Command {
	HLPlace newHLPlace;
	Token token, newToken;
	
	public CopyHLTokenCommand() {
		super();
	}


	/**
	 * Executes the command by adding the Token to the new HLPlace.
	 */
	@Override
	public void execute() {	
		newToken = (Token)EcoreUtil.copy(token);
		newHLPlace.getTokens().add(newToken);		
	}
	
	
	
	/**
	 * Undoes the command by removing the Token from the newHLPlace and adding it to the OldHLPlace.
	 */
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#undo()
	 */
	@Override
	public void undo() {
		newHLPlace.getTokens().remove(newToken);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.commands.Command#redo()
	 */
	@Override
	public void redo() {
		newHLPlace.getTokens().add(newToken);		
	}
	


	/**
	 * @param token the token to set
	 */
	public void setToken(Token token) {
		this.token = token;
	}


	/**
	 * @param newHLPlace the newHLPlace to set
	 */
	public void setNewHLPlace(HLPlace newHLPlace) {
		this.newHLPlace = newHLPlace;
	}
	
}
