	/**
	 * @author jochen
	 */

package roneditor.ronview.commands;

import roneditor.model.RONModelManager;
import ronmodel.RonmodelFactory;

public class CreateHLBendpointCommand extends AbstractHLBendpointCommand{
	
	public void execute(){
		
		RonmodelFactory mfc = RONModelManager.getFactory();
		
		bendPoint = mfc.createBendPoint();
		
		bendPoint.getH().add(new Integer(getFirstRelativeDimension().height));
		bendPoint.getW().add(new Integer(getFirstRelativeDimension().width));
		
		bendPoint.getH().add(new Integer(getSecondRelativeDimension().height));
		bendPoint.getW().add(new Integer(getSecondRelativeDimension().width));
		
		getHLArc().getBendpoints().add(getIndex(), bendPoint);
		
	}
	
	public void undo(){
		getHLArc().getBendpoints().remove(bendPoint);
	}
	
}
