package roneditor.ronview.commands;

import ronmodel.HLArc;
import ronmodel.HLNode;
import ronmodel.RON;


/**
 * Command for deleting a transition.
 */
public class DeleteHLArcCommand 
		extends org.eclipse.gef.commands.Command {
	private static final String DeleteCommand_Label = "DeleteTransitionCommand";
	private	 HLArc onArc;
	private HLNode source;
	private HLNode target;
	private RON objectNet;

	/**
	 * 
	 */
	public DeleteHLArcCommand() {
		super( DeleteCommand_Label );
	}

	/**
	 * Entry point for command execution.
	 */
	public void execute() {
		source = onArc.getSource();
		target = onArc.getTarget();
		objectNet = onArc.getRon();
		onArc.setRon(null);
		onArc.setSource(null);
		onArc.setTarget(null);
	}

	public void redo() {
		execute();
	}

	/**
	 * Undo command execution.
	 */
	public void undo() {
		onArc.setRon(objectNet);
				
		onArc.setSource(source);
		onArc.setTarget(target);
				
	}

	/**
	 * @return the onArc
	 */
	public HLArc getHLArc() {
		return onArc;
	}

	/**
	 * @param onArc the onArc to set
	 */
	public void setHLArc(HLArc onArc) {
		this.onArc = onArc;
	}

	/**
	 * @return the source
	 */
	public HLNode getSource() {
		return source;
	}

	/**
	 * @return the target
	 */
	public HLNode getTarget() {
		return target;
	}


}
