package roneditor.ronview.commands;

import java.util.List;

import org.eclipse.gef.commands.Command;

import ronmodel.HLPlace;
import ronmodel.Token;


/**
 * @author conny 
 * 
 * command for removing a given HLToken from its parent HLPlace
 */
public class OrphanChildCommand extends Command {
	
	private HLPlace place;
	private Token token;
	private int index;

	public OrphanChildCommand(Token _token) {
		super("Orphan Token");
		this.token = _token;
		this.place = this.token.getPlace();
	}

	public void execute() {
		List children = place.getTokens();
		index = children.indexOf(token);
		place.getTokens().remove(token);
	}

	public void redo() {
		place.getTokens().remove(token);
	}

	public void setChild(Token child) {
		this.token = child;
	}

	public void setParent(HLPlace parent) {
		place = parent;
	}

	public void undo() {
		place.getTokens().add(index, token);
	}

}
