package roneditor.ronview.commands;

import org.eclipse.draw2d.geometry.Point;

import ronmodel.HLNode;

/**
 * Change the location of a graphical object.
 */
public class SetHLConstraintCommand
	extends org.eclipse.gef.commands.Command
{
	private static final String Command_Label_Resize = 
		"Move HLNode Command";
	private Point newPosition;
	private Point oldPosition;
	
	private HLNode onNode;
	
	public void execute() {
		oldPosition  = new Point(onNode.getX(), onNode.getY() );
		onNode.setX(newPosition.x);
		onNode.setY(newPosition.y);
	}
	
	public String getLabel(){
		return Command_Label_Resize;
	}
	
	public void redo() {
		onNode.setX(newPosition.x);
		onNode.setY(newPosition.y);
	}
	
	public void undo() {
		onNode.setX(oldPosition.x);
		onNode.setY(oldPosition.y);
	}

	/**
	 * @return the newPosition
	 */
	public Point getNewPosition() {
		return newPosition;
	}

	/**
	 * @param newPosition the newPosition to set
	 */
	public void setNewPosition(Point newPosition) {
		this.newPosition = newPosition;
	}

	/**
	 * @return the node
	 */
	public HLNode getHLNode() {
		return onNode;
	}

	/**
	 * @param node the node to set
	 */
	public void setHLNode(HLNode node) {
		this.onNode = node;
	}
	
}
