package roneditor.ronview.edit.parts;

import java.util.Iterator;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.NodeEditPart;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;

import roneditor.edit.parts.LabelEditPart;
import ronmodel.HLNode;

public abstract class HLNodeEditPart	
	extends AbstractGraphicalEditPart
	implements NodeEditPart, Adapter
{


	private LabelEditPart labelEditPart;	
	
	/* (non-Javadoc)
	 * @see org.eclipse.emf.common.notify.Adapter#notifyChanged(org.eclipse.emf.common.notify.Notification)
	 */
	public void notifyChanged(Notification notification) {
	}
	

	/**
	 * 
	 * @return zugehrigen LabelEditPart
	 */
	public LabelEditPart getLabelEditPart() {
		if (labelEditPart == null) {
			Iterator iter = getParent().getChildren().iterator();
			EditPart editPart = null;
			while (iter.hasNext()) {
				if (((editPart = (EditPart)iter.next()) instanceof LabelEditPart) 
						&& (((LabelEditPart)editPart).getCastedModel() == this.getModel())) {
					labelEditPart = (LabelEditPart)editPart;
					break;
				}
			}
		}
		return labelEditPart;
	}
	
	private HLNode getHLNode() {
		return (HLNode)getModel();
	}
	
}
