/**
 * 
 */
package roneditor.ruleview.actions;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IEditorPart;

import roneditor.ruleview.RulePage;
import roneditor.ruleview.commands.CopyLhsToNacCommand;
import ronmodel.Rule;

/**
 * @author conny
 *
 * This action is use by a {@link RulePage} and copies the lhs to the current nac.
 */

public class CopyLhsToNacAction extends SelectionAction{

	static public final String ID = "Copy LHS to NAC Action";
	private RulePage rulePage;
	private Rule rule;
	
	public CopyLhsToNacAction(RulePage _rulePage, IEditorPart part) {
		super(part);
		setDescription("Copy LHS to NAC");
		setText("Copy LHS to NAC");
		setId(ID);
		this.rulePage = _rulePage;
		this.rule = _rulePage.getRule();
	}
	
	public void run(){
		execute(getCommand());
	}
	
	public Command getCommand(){
		
		CopyLhsToNacCommand cc = new CopyLhsToNacCommand();
	
		cc.setViewerContent(this.rulePage.getViewersContents(0));
		cc.setRule(this.rulePage.getRule());
		
		return cc;
	}

	
	protected boolean calculateEnabled() {
		return(!(this.rule.getLhs().getNodes().size() < 1) && !(this.rule.getNacs().isEmpty()));
	}	

	/* (non-Javadoc)
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#init()
	 */
	protected void init() {
		super.init();
		setId(ID);
	}
}
