/**
 * 
 */
package roneditor.ruleview.actions;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IEditorPart;

import roneditor.ruleview.RulePage;
import roneditor.ruleview.commands.CopyLhsToRhsCommand;
import ronmodel.Rule;

/**
 * @author conny
 *
 * This action is use by a {@link RulePage} and copies the lhs to the rhs.
 */

public class CopyLhsToRhsAction extends SelectionAction{

	static public final String ID = "Copy LHS to RHS Action";
	private RulePage rulePage;
	private Rule rule;
	
	public CopyLhsToRhsAction(RulePage _rulePage, IEditorPart part) {
		super(part);
		setDescription("Copy LHS to RHS");
		setText("Copy LHS to RHS");
		setId(ID);
		this.rulePage = _rulePage;
		this.rule = _rulePage.getRule();
	}
	
	public void run(){
		execute(getCommand());
	}
	
	public Command getCommand(){
		
		CopyLhsToRhsCommand cc = new CopyLhsToRhsCommand();

		cc.setRule(this.rulePage.getRule());
		
		return cc;
	}

	
	protected boolean calculateEnabled() {
		return(!(this.rule.getLhs().getNodes().size() < 1));
	}	

	/* (non-Javadoc)
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#init()
	 */
	protected void init() {
		super.init();
		setId(ID);
	}
}