/**
 * 
 */
package roneditor.ruleview.actions;

import java.util.List;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IEditorPart;

import roneditor.ruleview.RulePage;
import roneditor.ruleview.commands.DeleteNacCommand;
import ronmodel.NAC;
import ronmodel.Rule;

/**
 * @author Admin
 *
 */
public class DeleteNacAction extends SelectionAction {

	static public final String ID = "Delete Nac Action";
	private RulePage rulePage;
	private Rule rule;
	
	public DeleteNacAction(RulePage _rulePage, IEditorPart part) {
		super(part);
		setDescription("Delete Nac");
		setText("Delete Nac");
		setId(ID);
		this.rulePage = _rulePage;
		this.rule = _rulePage.getRule();
	}
	
	public void run(){
		execute(getCommand());
	}
	
	public Command getCommand(){
		final List nacs = rulePage.getRule().getNacs();
		final int actualShowing = nacs.lastIndexOf(rulePage
				.getViewersContents(0));	
		
		DeleteNacCommand dnc = new DeleteNacCommand();
		
		dnc.setDeleteNac((NAC)nacs.get(actualShowing));

		dnc.setRulePage(rulePage);		
		return dnc;
	}

	
	protected boolean calculateEnabled() {
		return rulePage.getRule().getNacs().size() > 0;
	}	

	/* (non-Javadoc)
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#init()
	 */
	protected void init() {
		super.init();
		setId(ID);
	}
}
