/**
 * <copyright>
 * </copyright>
 *
 * $Id: Mapping.java,v 1.3 2007/07/07 16:30:19 calistar Exp $
 */
package ronmodel;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Mapping</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ronmodel.Mapping#getSource <em>Source</em>}</li>
 *   <li>{@link ronmodel.Mapping#getTarget <em>Target</em>}</li>
 *   <li>{@link ronmodel.Mapping#getCodomain <em>Codomain</em>}</li>
 *   <li>{@link ronmodel.Mapping#getMappingNr <em>Mapping Nr</em>}</li>
 * </ul>
 * </p>
 *
 * @see ronmodel.RonmodelPackage#getMapping()
 * @model
 * @generated
 */
public interface Mapping extends EObject {
	/**
	 * Returns the value of the '<em><b>Source</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link ronmodel.ONNode#getOutgoingM <em>Outgoing M</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source</em>' reference.
	 * @see #setSource(ONNode)
	 * @see ronmodel.RonmodelPackage#getMapping_Source()
	 * @see ronmodel.ONNode#getOutgoingM
	 * @model opposite="outgoingM"
	 * @generated
	 */
	ONNode getSource();

	/**
	 * Sets the value of the '{@link ronmodel.Mapping#getSource <em>Source</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source</em>' reference.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(ONNode value);

	/**
	 * Returns the value of the '<em><b>Target</b></em>' reference.
	 * It is bidirectional and its opposite is '{@link ronmodel.ONNode#getIncomingM <em>Incoming M</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(ONNode)
	 * @see ronmodel.RonmodelPackage#getMapping_Target()
	 * @see ronmodel.ONNode#getIncomingM
	 * @model opposite="incomingM"
	 * @generated
	 */
	ONNode getTarget();

	/**
	 * Sets the value of the '{@link ronmodel.Mapping#getTarget <em>Target</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(ONNode value);

	/**
	 * Returns the value of the '<em><b>Codomain</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ronmodel.Codomain#getMappings <em>Mappings</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Codomain</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Codomain</em>' container reference.
	 * @see #setCodomain(Codomain)
	 * @see ronmodel.RonmodelPackage#getMapping_Codomain()
	 * @see ronmodel.Codomain#getMappings
	 * @model opposite="mappings"
	 * @generated
	 */
	Codomain getCodomain();

	/**
	 * Sets the value of the '{@link ronmodel.Mapping#getCodomain <em>Codomain</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Codomain</em>' container reference.
	 * @see #getCodomain()
	 * @generated
	 */
	void setCodomain(Codomain value);

	/**
	 * Returns the value of the '<em><b>Mapping Nr</b></em>' attribute.
	 * The default value is <code>"-1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mapping Nr</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mapping Nr</em>' attribute.
	 * @see #setMappingNr(int)
	 * @see ronmodel.RonmodelPackage#getMapping_MappingNr()
	 * @model default="-1"
	 * @generated
	 */
	int getMappingNr();

	/**
	 * Sets the value of the '{@link ronmodel.Mapping#getMappingNr <em>Mapping Nr</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mapping Nr</em>' attribute.
	 * @see #getMappingNr()
	 * @generated
	 */
	void setMappingNr(int value);

} // Mapping