/**
 * <copyright>
 * </copyright>
 *
 * $Id: ONNode.java,v 1.6 2007/07/07 07:13:11 connybln Exp $
 */
package ronmodel;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>ON Node</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link ronmodel.ONNode#getOutgoing <em>Outgoing</em>}</li>
 *   <li>{@link ronmodel.ONNode#getIncoming <em>Incoming</em>}</li>
 *   <li>{@link ronmodel.ONNode#getObjectNet <em>Object Net</em>}</li>
 *   <li>{@link ronmodel.ONNode#getOutgoingM <em>Outgoing M</em>}</li>
 *   <li>{@link ronmodel.ONNode#getIncomingM <em>Incoming M</em>}</li>
 * </ul>
 * </p>
 *
 * @see ronmodel.RonmodelPackage#getONNode()
 * @model abstract="true"
 * @generated
 */
public interface ONNode extends NamedElement {
	/**
	 * Returns the value of the '<em><b>Outgoing</b></em>' reference list.
	 * The list contents are of type {@link ronmodel.ONArc}.
	 * It is bidirectional and its opposite is '{@link ronmodel.ONArc#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outgoing</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Outgoing</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_Outgoing()
	 * @see ronmodel.ONArc#getSource
	 * @model type="ronmodel.ONArc" opposite="source"
	 * @generated
	 */
	EList getOutgoing();

	/**
	 * Returns the value of the '<em><b>Incoming</b></em>' reference list.
	 * The list contents are of type {@link ronmodel.ONArc}.
	 * It is bidirectional and its opposite is '{@link ronmodel.ONArc#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Incoming</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Incoming</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_Incoming()
	 * @see ronmodel.ONArc#getTarget
	 * @model type="ronmodel.ONArc" opposite="target"
	 * @generated
	 */
	EList getIncoming();

	/**
	 * Returns the value of the '<em><b>Object Net</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link ronmodel.ObjectNet#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Object Net</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Object Net</em>' container reference.
	 * @see #setObjectNet(ObjectNet)
	 * @see ronmodel.RonmodelPackage#getONNode_ObjectNet()
	 * @see ronmodel.ObjectNet#getNodes
	 * @model opposite="nodes"
	 * @generated
	 */
	ObjectNet getObjectNet();

	/**
	 * Sets the value of the '{@link ronmodel.ONNode#getObjectNet <em>Object Net</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Object Net</em>' container reference.
	 * @see #getObjectNet()
	 * @generated
	 */
	void setObjectNet(ObjectNet value);

//	/**  MOVED TO NAMENDELEMENT
	
//	 * Returns the value of the '<em><b>X</b></em>' attribute.
//	 * <!-- begin-user-doc -->
//	 * <p>
//	 * If the meaning of the '<em>X</em>' attribute isn't clear,
//	 * there really should be more of a description here...
//	 * </p>
//	 * <!-- end-user-doc -->
//	 * @return the value of the '<em>X</em>' attribute.
//	 * @see #setX(int)
//	 * @see ronmodel.RonmodelPackage#getONNode_X()
//	 * @model
//	 * @generated
//	 */
//	int getX();
//
//	/**
//	 * Sets the value of the '{@link ronmodel.ONNode#getX <em>X</em>}' attribute.
//	 * <!-- begin-user-doc -->
//	 * <!-- end-user-doc -->
//	 * @param value the new value of the '<em>X</em>' attribute.
//	 * @see #getX()
//	 * @generated
//	 */
//	void setX(int value);
//
//	/**
//	 * Returns the value of the '<em><b>Y</b></em>' attribute.
//	 * <!-- begin-user-doc -->
//	 * <p>
//	 * If the meaning of the '<em>Y</em>' attribute isn't clear,
//	 * there really should be more of a description here...
//	 * </p>
//	 * <!-- end-user-doc -->
//	 * @return the value of the '<em>Y</em>' attribute.
//	 * @see #setY(int)
//	 * @see ronmodel.RonmodelPackage#getONNode_Y()
//	 * @model
//	 * @generated
//	 */
//	int getY();
//
//	/**
//	 * Sets the value of the '{@link ronmodel.ONNode#getY <em>Y</em>}' attribute.
//	 * <!-- begin-user-doc -->
//	 * <!-- end-user-doc -->
//	 * @param value the new value of the '<em>Y</em>' attribute.
//	 * @see #getY()
//	 * @generated
//	 */
//	void setY(int value);
//
//	/**
//	 * Returns the value of the '<em><b>Outgoing M</b></em>' reference list.
//	 * The list contents are of type {@link ronmodel.Mapping}.
//	 * It is bidirectional and its opposite is '{@link ronmodel.Mapping#getSource <em>Source</em>}'.
//	 * <!-- begin-user-doc -->
//	 * <p>
//	 * If the meaning of the '<em>Outgoing M</em>' reference list isn't clear,
//	 * there really should be more of a description here...
//	 * </p>
//	 * <!-- end-user-doc -->
//	 * @return the value of the '<em>Outgoing M</em>' reference list.
//	 * @see ronmodel.RonmodelPackage#getONNode_OutgoingM()
//	 * @see ronmodel.Mapping#getSource
//	 * @model type="ronmodel.Mapping" opposite="source"
//	 * @generated
//	 */
//	EList getOutgoingM();
//
//	/**
//	 * Returns the value of the '<em><b>Incoming M</b></em>' reference list.
//	 * The list contents are of type {@link ronmodel.Mapping}.
//	 * It is bidirectional and its opposite is '{@link ronmodel.Mapping#getTarget <em>Target</em>}'.
//	 * <!-- begin-user-doc -->
//	 * <p>
//	 * If the meaning of the '<em>Incoming M</em>' reference list isn't clear,
//	 * there really should be more of a description here...
//	 * </p>
//	 * <!-- end-user-doc -->
//	 * @return the value of the '<em>Incoming M</em>' reference list.
//	 * @see ronmodel.RonmodelPackage#getONNode_IncomingM()
//	 * @see ronmodel.Mapping#getTarget
//	 * @model type="ronmodel.Mapping" opposite="target"
//	 * @generated
//	 */
//	EList getIncomingM();
//
//	/**
//	 * Returns the value of the '<em><b>Label X</b></em>' attribute.
//	 * The default value is <code>"0"</code>.
//	 * <!-- begin-user-doc -->
//	 * <p>
//	 * If the meaning of the '<em>Label X</em>' attribute isn't clear,
//	 * there really should be more of a description here...
//	 * </p>
//	 * <!-- end-user-doc -->
//	 * @return the value of the '<em>Label X</em>' attribute.
//	 * @see #setLabelX(int)
//	 * @see ronmodel.RonmodelPackage#getONNode_LabelX()
//	 * @model default="0"
//	 * @generated
//	 */
//	int getLabelX();
//
//	/**
//	 * Sets the value of the '{@link ronmodel.ONNode#getLabelX <em>Label X</em>}' attribute.
//	 * <!-- begin-user-doc -->
//	 * <!-- end-user-doc -->
//	 * @param value the new value of the '<em>Label X</em>' attribute.
//	 * @see #getLabelX()
//	 * @generated
//	 */
//	void setLabelX(int value);
//
//	/**
//	 * Returns the value of the '<em><b>Label Y</b></em>' attribute.
//	 * The default value is <code>"30"</code>.
//	 * <!-- begin-user-doc -->
//	 * <p>
//	 * If the meaning of the '<em>Label Y</em>' attribute isn't clear,
//	 * there really should be more of a description here...
//	 * </p>
//	 * <!-- end-user-doc -->
//	 * @return the value of the '<em>Label Y</em>' attribute.
//	 * @see #setLabelY(int)
//	 * @see ronmodel.RonmodelPackage#getONNode_LabelY()
//	 * @model default="30"
//	 * @generated
//	 */
//	int getLabelY();
//
//	/**
//	 * Sets the value of the '{@link ronmodel.ONNode#getLabelY <em>Label Y</em>}' attribute.
//	 * <!-- begin-user-doc -->
//	 * <!-- end-user-doc -->
//	 * @param value the new value of the '<em>Label Y</em>' attribute.
//	 * @see #getLabelY()
//	 * @generated
//	 */
//	void setLabelY(int value);

	/**
	 * Returns the value of the '<em><b>Outgoing M</b></em>' reference list.
	 * The list contents are of type {@link ronmodel.Mapping}.
	 * It is bidirectional and its opposite is '{@link ronmodel.Mapping#getSource <em>Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Outgoing M</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Outgoing M</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_OutgoingM()
	 * @see ronmodel.Mapping#getSource
	 * @model type="ronmodel.Mapping" opposite="source"
	 * @generated
	 */
	EList getOutgoingM();

	/**
	 * Returns the value of the '<em><b>Incoming M</b></em>' reference list.
	 * The list contents are of type {@link ronmodel.Mapping}.
	 * It is bidirectional and its opposite is '{@link ronmodel.Mapping#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Incoming M</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Incoming M</em>' reference list.
	 * @see ronmodel.RonmodelPackage#getONNode_IncomingM()
	 * @see ronmodel.Mapping#getTarget
	 * @model type="ronmodel.Mapping" opposite="target"
	 * @generated
	 */
	EList getIncomingM();

} // ONNode